/**
 ** @author: Ben Y. Zhao (ravenben@cs.berkeley.edu)
 ** @version: CVS Version: $Revision: 1.3 $  Date: $Date: 1999/09/13 18:50:27 $
 ** (c) 2000 by Ben Yanbin Zhao and the Regents of the University of California
 **/

package ninja.xset;

import java.util.Vector;
import org.w3c.dom.*;

public interface XSetServiceIF extends java.rmi.Remote {

  //METHODS to add documents
  public void AddDocument(String xmlstring) 
    throws java.rmi.RemoteException; 
  //adding a single XML string to the dataset
  public void AddFiles(String path) 
    throws java.rmi.RemoteException;
  //adding an entire directory to the dataset
  public void AddFile(String filename)
    throws java.rmi.RemoteException;
  //adding one single file to the dataset

  //METHODS to Query documents
  public Vector QuerySE(String xmlQuery) 
    throws java.rmi.RemoteException;
  //query the server and get back a vector of ServiceEntry objects
  public Vector Query(String xmlQuery) 
    throws java.rmi.RemoteException;
  //query the server and get back a vector of XML strings
  public Vector Query(String xmlQuery, Vector tagVector)
    throws java.rmi.RemoteException;
  //query the server and get back a vector of hashtables with requested tags
  public Vector EnumerateTag(String [] pathArray) 
    throws java.rmi.RemoteException;
  //ask the server to return all existing values for a named tag in the index

  //METHODS to remove documents
  public void RemoveDocument(Document d) 
    throws java.rmi.RemoteException;
  //removes the document given the DOM document object
  public void RemoveDocument(String xml) 
    throws java.rmi.RemoteException;
  //removes the document given the canonical XML string representation
  public void ClearAll() 
    throws java.rmi.RemoteException;
  //clear the entire dataset

  //Other methods
  public int Shutdown(boolean backup)
    throws java.rmi.RemoteException;
  //shutdown the XSetService, optionally doing a checkpoint before shutdown

  public boolean Checkpoint()
    throws java.rmi.RemoteException;
  //synchronous checkpointing method, returns success (0) or failure(-1)

  public void ForceSync()
    throws java.rmi.RemoteException;
  //synchronous forced writeout of the log buffer, returns success (0) or (-1)
}
